package org.steveshipway.blueprints.directive;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.logging.log4j.Logger;
import org.steveshipway.blueprints.lib.Constants;

public class AutoDirective extends Directive {
	public Set biomes = new HashSet();
	
	public AutoDirective( int auto_chance, String biomeString ) {
   		this.auto_chance = (float)auto_chance/(float)Constants.CHANCE_BASE;
   	    for (String retval: biomeString.split("\\s*,+\\s*")){
   	    	this.biomes.add(retval);
	    }
	}
	public AutoDirective(String definition, Logger logger) {
    	Pattern p = Pattern.compile("(?i)^(?:\\s*auto)\\s*(\\d+)%?\\s*(.*)");
    	Matcher m = p.matcher(definition);
    	if( m.find() ) {
    		try {
	    		this.auto_chance = (float)Integer.parseInt(m.group(1))/(float)Constants.CHANCE_BASE;
	    	    for (String retval: m.group(2).split("\\s*,+\\s*")){
	    	          biomes.add(retval);
	    	    }
	    	    //logger.info("Setting auto-generation chance to " + this.auto_chance);
    		} catch( Exception e ) {
        		logger.error("Bad Auto definition: "+definition);    			
    		}
    	} else {
    		logger.error("Bad Auto definition: "+definition);
    	}
	}
	
	@Override
	public String asText() {
		if( this.auto_chance > 0 ) {
			String s = "AUTO "+Math.floor(this.auto_chance*Constants.CHANCE_BASE)+" ";
			Iterator i = biomes.iterator();
			while( i.hasNext())  {
				s = s + " " + i.next();
			}
			return s;
		} else {
			return "# AUTO undefined";
		}
	}
}
